#define INCL_WIN
#define INCL_DOS
#define INCL_GPI
#include <os2.h>
#include "npunzip.h"
#include "string.h"
#include "stdio.h"
#include "stdlib.h"
#include "unzip.h"
typedef struct _USERRECORD
{
  RECORDCORE  recordCore;
  PCHAR       filename;
  ULONG       file_size;
  ULONG       ea_size;
  ULONG       acl_size;
  CHAR        f1[255];
} USERRECORD, *PUSERRECORD;
PUSERRECORD      pUserRecord;
RECORDINSERT     recordInsert;
HWND             hwnd_cont;

int _System getdir(char *filename,cdir_file_hdr *p,int easize,int aclsize)
{
   pUserRecord->recordCore.cb = sizeof(RECORDCORE);              /*RBS*/
   pUserRecord->recordCore.pszText = filename;
   pUserRecord->recordCore.pszIcon = filename;
   pUserRecord->recordCore.pszName = filename;
   pUserRecord->recordCore.hptrIcon = 0;
   strcpy(pUserRecord->f1,filename);
   pUserRecord->filename = pUserRecord->f1;
   pUserRecord->file_size = p->ucsize;
   pUserRecord->ea_size   = easize;
   pUserRecord->acl_size  = aclsize;

   recordInsert.cb = sizeof(RECORDINSERT);                   /*RBS*/
   recordInsert.pRecordParent= NULL;
   recordInsert.pRecordOrder = (PRECORDCORE)CMA_END;
   recordInsert.zOrder = CMA_TOP;
   recordInsert.cRecordsInsert = 1;
   recordInsert.fInvalidateRecord = TRUE;

   WinSendDlgItemMsg(hwnd_cont,ID_CONTAINER, CM_INSERTRECORD,
                    (PRECORDCORE)pUserRecord, &recordInsert);
   return 0;
}
MRESULT EXPENTRY NPUnzipProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
   USHORT           nRecords = 1;
   ULONG            cbRecordData;
   PFIELDINFO       pFieldInfo, firstFieldInfo;
   FIELDINFOINSERT  fieldInfoInsert;
   PFIELDINFOINSERT pFieldInfoInsert;
   CNRINFO          cnrinfo;
   ULONG            ulCnrAttributes;
   HPOINTER         hptr;
   CHAR             zipver[40];
  char           *cpinclude[2];
  char           *cpexclude[2];
  int            rc;

   switch(msg)
    {
       case WM_INITDLG:
             hwnd_cont = hwnd;
             WinSetDlgItemText(hwnd,ID_ZIPFILE,"f:\\test.zip");
             WinSetDlgItemText(hwnd,ID_INCMASK,"*");
             cbRecordData = (LONG) (sizeof(USERRECORD) - sizeof(RECORDCORE));
             pUserRecord = (PUSERRECORD) WinSendDlgItemMsg(hwnd,ID_CONTAINER,
                                                           CM_ALLOCRECORD, MPFROMLONG(cbRecordData) ,
                                                           MPFROMSHORT(nRecords));
             cpinclude[0] = "*";
             cpinclude[1] = NULL;

             cpexclude[0] = NULL;
             cpexclude[1] = NULL;
             rc = UzpFileTree("f:\\test.zip",
                              getdir,
                              cpinclude,
                              cpexclude);
             pFieldInfo = (PFIELDINFO) WinSendDlgItemMsg(hwnd, ID_CONTAINER,
                                                         CM_ALLOCDETAILFIELDINFO,MPFROMLONG(4), NULL);

             firstFieldInfo = pFieldInfo;

             pFieldInfo->cb = sizeof(FIELDINFO);
             pFieldInfo->flData = CFA_STRING | CFA_HORZSEPARATOR | CFA_CENTER;


             pFieldInfo->flTitle = CFA_CENTER;
             pFieldInfo->pTitleData = (PVOID) "Filename";
             pFieldInfo->offStruct = 56;
             pFieldInfo = pFieldInfo->pNextFieldInfo;

             pFieldInfo->cb = sizeof(FIELDINFO);
             pFieldInfo->flData = CFA_ULONG  | CFA_HORZSEPARATOR | CFA_CENTER |
                                  CFA_SEPARATOR;
             pFieldInfo->flTitle = CFA_CENTER;
             pFieldInfo->pTitleData =  (PVOID) "File size";
             pFieldInfo->offStruct = 60;
             pFieldInfo = pFieldInfo->pNextFieldInfo;

             pFieldInfo->cb = sizeof(FIELDINFO);
             pFieldInfo->flData = CFA_ULONG  | CFA_HORZSEPARATOR | CFA_CENTER |
                                  CFA_SEPARATOR;
             pFieldInfo->flTitle = CFA_CENTER;
             pFieldInfo->pTitleData = (PVOID) "EA Size";
             pFieldInfo->offStruct = 64;
             pFieldInfo = pFieldInfo->pNextFieldInfo;

             pFieldInfo->cb = sizeof(FIELDINFO);
             pFieldInfo->flData = CFA_ULONG  | CFA_HORZSEPARATOR | CFA_CENTER |
                                  CFA_SEPARATOR;
             pFieldInfo->flTitle = CFA_CENTER;
             pFieldInfo->pTitleData = (PVOID) "ACL Size";
             pFieldInfo->offStruct = 68;


             fieldInfoInsert.cb = (ULONG)(sizeof(FIELDINFOINSERT));
             fieldInfoInsert.pFieldInfoOrder = (PFIELDINFO)CMA_FIRST;
             fieldInfoInsert.cFieldInfoInsert = 4;
             fieldInfoInsert.fInvalidateFieldInfo = TRUE;

             pFieldInfoInsert = &fieldInfoInsert;

             WinSendDlgItemMsg(hwnd,ID_CONTAINER, CM_INSERTDETAILFIELDINFO,
                               MPFROMP(firstFieldInfo),
                               MPFROMP(pFieldInfoInsert));
             cnrinfo.flWindowAttr  = CV_DETAIL|CA_DETAILSVIEWTITLES;
             WinSendDlgItemMsg(hwnd,ID_CONTAINER,CM_SETCNRINFO,MPFROMP(&cnrinfo),
                               MPFROMLONG(CMA_FLWINDOWATTR));
             cnrinfo.xVertSplitbar  = 200;
             cnrinfo.pFieldInfoLast = firstFieldInfo;
             WinSendDlgItemMsg(hwnd,ID_CONTAINER,CM_SETCNRINFO,MPFROMP(&cnrinfo),
                               MPFROMLONG(CMA_XVERTSPLITBAR|CMA_PFIELDINFOLAST));
             break;
       case WM_ERASEBACKGROUND:
             return (MRESULT) TRUE;
            break;
      default:
              return WinDefDlgProc(hwnd, msg, mp1, mp2);
              break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}
int main(int argc,char **argv)
{
    APIRET         rc;
    HMODULE        hModule;
    HAB            hab;
    HMQ            hmq;


    hab = WinInitialize(0);
    hmq = WinCreateMsgQueue(hab,0);

    WinDlgBox  (HWND_DESKTOP,
                HWND_DESKTOP,
                (PFNWP)NPUnzipProc,
                0,
                ID_NPUNZIP,
                0);
    WinDestroyMsgQueue(hmq);
    WinTerminate(hab);
}
